unix {
  contains(DEFINES, XERCES) {
    !isEmpty ( XERCES22_DIR ) {
      XERCES22_LIB_DIR=$$XERCES22_DIR/lib
      XERCES22_INCLUDE_DIR=$$XERCES22_DIR/include
    }
    else {
      isEmpty ( XERCES22_LIB_DIR ) {
        XERCES22_LIB_DIR=/usr/local/lib
      } 
      isEmpty ( XERCES22_INCLUDE_DIR ) {
        XERCES22_INCLUDE_DIR=/usr/local/include
      }
    }

    !exists ( $$XERCES22_LIB_DIR/libxerces-c.so.22 ) {
     error ( not found libxerces-c.so.22 in $$XERCES22_LIB_DIR ! specify XERCES22_DIR or XERCES22_LIB_DIR if installed elsewhere )
     }
  
    !exists ( $$XERCES22_INCLUDE_DIR/xercesc ) {
      error ( not found $$XERCES22_INCLUDE_DIR/xercesc ! specify XERCES22_DIR or XERCES22_INCLUDE_DIR if installed elsewhere )
    }
  }

  !isEmpty ( QGLVIEWER_DIR ) {
    QGLVIEWER_LIB_DIR=$$QGLVIEWER_DIR/lib
    QGLVIEWER_INCLUDE_DIR=$$QGLVIEWER_DIR/include
  }
  else {
    isEmpty ( QGLVIEWER_LIB_DIR ) {
      QGLVIEWER_LIB_DIR=/usr/local/lib
    } 
    isEmpty ( QGLVIEWER_INCLUDE_DIR ) {
      QGLVIEWER_INCLUDE_DIR=/usr/local/include
    }
  }

  !exists ( $$QGLVIEWER_LIB_DIR/libQGLViewer.so ) {
    error ( not found libQGLViewer.so in $$QGLVIEWER_LIB_DIR ! specify QGLVIEWER_DIR or QGLVIEWER_LIB_DIR if installed elsewhere )
  }
  
  !exists ( $$QGLVIEWER_INCLUDE_DIR ) {
    error ( not found $$QGLVIEWER_INCLUDE_DIR ! specify QGLVIEWER_DIR or QGLVIEWER_INCLUDE_DIR if installed elsewhere )
  }
  
  !isEmpty( X3DTK_DIR ) {
    X3DTK_LIB_DIR = $$X3DTK_DIR/lib
    X3DTK_INCLUDE_DIR = $$X3DTK_DIR/include
  }
  else {
    isEmpty( X3DTK_LIB_DIR ) {
      X3DTK_LIB_DIR = /usr/local/lib
    }

    isEmpty( X3DTK_INCLUDE_DIR ) {
      X3DTK_INCLUDE_DIR = /usr/local/include
    }
  }  

  !exists ( $$X3DTK_LIB_DIR/libX3DTK.so ) {
    error ( not found libX3DTK.so in $$X3DTK_LIB_DIR ! specify X3DTK_DIR or X3DTK_LIB_DIR if installed elsewhere )
  }
  
  !exists ( $$X3DTK_INCLUDE_DIR ) {
    error ( not found $$X3DTK_INCLUDE_DIR ! specify X3DTK_DIR or X3DTK_INCLUDE_DIR if installed elsewhere )
  }
}

INCLUDEPATH *= $$X3DTK_INCLUDE_DIR \
               $$QGLVIEWER_INCLUDE_DIR \
               
contains(DEFINES, XERCES) {
  INCLUDEPATH *= $$XERCES22_INCLUDE_DIR/xercesc
  LIBS *= -L$$X3DTK_LIB_DIR -lX3DTK -L$$XERCES22_LIB_DIR -lxerces-c -L$$QGLVIEWER_LIB_DIR -lQGLViewer
}               
else {
  LIBS *= -L$$X3DTK_LIB_DIR -lX3DTK -L$$QGLVIEWER_LIB_DIR -lQGLViewer  
}

               

