////////////////////////////////////////////////////////////////////////////////
//                            GLSimpleAnimator.h                              //
////////////////////////////////////////////////////////////////////////////////

#ifndef GLSIMPLEANIMATOR_H
#define GLSIMPLEANIMATOR_H

#include "GLSimpleAnimatorGlobalVariables.h"

#include <X3DTK/kernel.h>

namespace X3DTK {
namespace GL {

/// X3DSimpleAnimator concept.

class SimpleAnimator : public X3DTTAlgorithm
{
public:
  /// Constructor.
  SimpleAnimator();
  /// Destructor.
  virtual ~SimpleAnimator();
  
  /// Sets the Bbox size.  
  void setBboxSize(const SFVec3f &size);
  /// Animates the scene.
  virtual void animate(SFNode N, float time);
 
protected:
  SimpleAnimatorGlobalVariables *globalVariables;
  DFS *dfs;
};

}
}

#endif
