////////////////////////////////////////////////////////////////////////////////
//                            GLSimpleAnimatorGlobalVariables.h               //
////////////////////////////////////////////////////////////////////////////////

#ifndef GLSIMPLEANIMATORGLOBALVARIABLES_H
#define GLSIMPLEANIMATORGLOBALVARIABLES_H

#include <X3DTK/kernel.h>

namespace X3DTK {
namespace GL {

/// GlobalVariables for the SimpleAnimator module.

class SimpleAnimatorGlobalVariables : public GlobalVariables
{
public:
  /// Constructor.
  SimpleAnimatorGlobalVariables();
  /// Destructor.
  virtual ~SimpleAnimatorGlobalVariables();

  /// Sets the bboxSize.
  void setBboxSize(const SFVec3f &size);
  /// Sets the time.
  void setTime(float time);

  /// Gets the time.
  float getTime() const {return _time;};
  /// Sets the bboxSize.
  inline SFVec3f getBboxSize() const {return _bboxSize;};
  
private: 
  float _time;
  SFVec3f _bboxSize;
};

}
}

#endif
