////////////////////////////////////////////////////////////////////////////////
//                            AbstractVisitor.h                               //
////////////////////////////////////////////////////////////////////////////////

#ifndef ABSTRACTVISITOR_H
#define ABSTRACTVISITOR_H

#include "X3DComponentVisitor.h"

namespace X3DTK {

/// Concrete component Visitor for the Abstract component.

class AbstractVisitor : public X3DComponentVisitor
{
public:
  /// Constructor.
  AbstractVisitor();
  /// Destructor.
  virtual ~AbstractVisitor();
  
  /// Enters an X3DAbstractNode.
  virtual void enterX3DAbstractNode(SFAbstractNode N) const;
  /// Walks on an X3DAbstractNode.
  virtual bool walkOnX3DAbstractNode(SFAbstractNode N, SFAbstractNode child) const;
  /// Enters an X3DAbstractNode.
  virtual void leaveX3DAbstractNode(SFAbstractNode N) const;
};

}

#endif
