////////////////////////////////////////////////////////////////////////////////
//                            Bbox.h                                         //
////////////////////////////////////////////////////////////////////////////////

#ifndef BBOX_H
#define BBOX_H

#include "X3DTypes.h"

namespace X3DTK {

/// Class providing a Bounding Box. The attributes are  a center and size a vector 
/// representing the diagonal.

class Bbox
{
public:
  /// Default constructor.
  Bbox();
  /// Constructor with center of the Bbox and its size.
  Bbox(const SFVec3f &center, const SFVec3f &size);
  /// Constructs th Bounding Box of the vertices of the node coord.
  explicit Bbox(const MFVec3f &coord);
  /// Copy constructor.
  Bbox::Bbox(const Bbox &B);
  
  /// Sets the center of the Bounding Box.
  inline void setCenter(const SFVec3f &center) {center_ = center;};
  /// Sets the Size of the Bounding Box.
  inline void setSize(const SFVec3f &size) {size_ = size;};
  
  /// Gets the center of the Bounding Box.
  inline SFVec3f getCenter() const {return center_;};
  /// Gets the size of the Bounding Box.
  inline SFVec3f getSize() const {return size_;};
  
private:
  SFVec3f center_;
  SFVec3f size_;  
};

}

#endif
