////////////////////////////////////////////////////////////////////////////////
//                            BboxDrawArray.h                                 //
////////////////////////////////////////////////////////////////////////////////

#ifndef BBOXDRAWARRAY_H
#define BBOXDRAWARRAY_H

#include "X3DTypes.h"

#include <vector>

namespace X3DTK {
namespace GL {

/// Class providing the arrays required by the glDrawElements() command for drawing a 
/// Bounding Box with corners.

class BboxDrawArray
{
public:
  /// Constructor.
  BboxDrawArray();
  
  /// Gets the size of the Box, it means the number of vertices displayed.
  unsigned int getBboxSize() const;
  /// Gets the address of the first element of the vertex array.
  const void *getBboxVertexArrayAddress() const;
  /// Gets the address of the first index.
  const unsigned int *getBboxIndexArrayAddress() const;

protected:
  const float h;
  MFVec3f _bboxVertexArray;
  std::vector<unsigned int> _bboxIndexArray; 
};

}
}

#endif
