////////////////////////////////////////////////////////////////////////////////
//                            BboxUpdaterCoreVisitor.h                        //
////////////////////////////////////////////////////////////////////////////////

#ifndef BBOXUPDATERCOREVISITOR_H
#define BBOXUPDATERCOREVISITOR_H

#include "CoreVisitor.h"
#include "BboxUpdaterGlobalVariables.h"

namespace X3DTK {
namespace X3D {

class X3DNode;
class Scene;

/// Visitor for the Core component of the BboxUpdater module.

class BboxUpdaterCoreVisitor : public CoreVisitor
{
public:
  /// Constructor.
  BboxUpdaterCoreVisitor();
  /// Destructor.
  virtual ~BboxUpdaterCoreVisitor();


  /// Walks on a X3DNode.
  virtual bool walkOnX3DNode(X3DNode *N, SFAbstractNode Child) const;
  
  /// Leaves a Scene.
  virtual void leaveScene(Scene *S) const;

protected:
  BboxUpdaterGlobalVariables *globalVariables;
};

}
}

#endif
