////////////////////////////////////////////////////////////////////////////////
//                            BboxUpdaterGeometry3DVisitor.h                  //
////////////////////////////////////////////////////////////////////////////////

#ifndef BBOXUPDATERGEOMETRY3DVISITOR_H
#define BBOXUPDATERGEOMETRY3DVISITOR_H

#include "Geometry3DVisitor.h"
#include "BboxUpdaterGlobalVariables.h"

namespace X3DTK {
namespace X3D {

class Box;
class Cone;
class Cylinder;
class Sphere;

/// Visitor for the Geometry3D component of the BboxUpdater module.

class BboxUpdaterGeometry3DVisitor : public Geometry3DVisitor
{
public:
  /// Constructor.
  BboxUpdaterGeometry3DVisitor();
  /// Destructor.
  virtual ~BboxUpdaterGeometry3DVisitor();

  /// Enters a Box.
  virtual void enterBox(Box *B) const;
  /// Enters a Cone.
  virtual void enterCone(Cone *C) const;
  /// Enters a Cylinder.
  virtual void enterCylinder(Cylinder *C) const;
  /// Enters a Sphere.
  virtual void enterSphere(Sphere *S) const;



protected:
  BboxUpdaterGlobalVariables *globalVariables;
};

}
}

#endif
