////////////////////////////////////////////////////////////////////////////////
//                            BboxUpdaterShapeVisitor.h                       //
////////////////////////////////////////////////////////////////////////////////

#ifndef BBOXUPDATERSHAPEVISITOR_H
#define BBOXUPDATERSHAPEVISITOR_H

#include "ShapeVisitor.h"
#include "BboxUpdaterGlobalVariables.h"

namespace X3DTK {
namespace X3D {

class X3DShapeNode;
class Shape;

/// Visitor for the Shape component of the BboxUpdater module.

class BboxUpdaterShapeVisitor : public ShapeVisitor
{
public:
  /// Constructor.
  BboxUpdaterShapeVisitor();
  /// Destructor.
  virtual ~BboxUpdaterShapeVisitor();


  /// Walks on a X3DShapeNode.
  virtual bool walkOnX3DShapeNode(X3DShapeNode *N, SFAbstractNode Child) const;

  /// Enters a X3DShapeNode.
  virtual void leaveShape(Shape *S) const;

protected:
  BboxUpdaterGlobalVariables *globalVariables;
};

}
}

#endif
