////////////////////////////////////////////////////////////////////////////////
//                            BoxDrawArray.h                                  //
////////////////////////////////////////////////////////////////////////////////

#ifndef BOXARRAY_H
#define BOXARRAY_H

#include "X3DTypes.h"
#include "X3DGLTypes.h"

#include <vector>

namespace X3DTK {
namespace GL {

/// Class providing the arrays required by the opengl command drawElements() to draw
/// a Box.

class BoxDrawArray
{
public:
  /// Gets the CylinderDrawArray of section section.
  static BoxDrawArray *getInstance();
  /// Removes the CylinderDrawArray of section section.
  void removeInstance();

  /// Gets the size of the Box, it means the number of vertices displayed.
  unsigned int getBoxSize() const;
  /// Gets the address of the first element of the vertex array.
  const void *getBoxVertexArrayAddress() const;
  /// Gets the address of the first index.
  const unsigned int *getBoxIndexArrayAddress() const;

private:
  /// Constructor.
  BoxDrawArray();
  
  static int _count;
  static BoxDrawArray *_ref;
  
  std::vector<N3F_V3F> _boxVertexArray;
  std::vector<unsigned int> _boxIndexArray;
};

}
}

#endif
