////////////////////////////////////////////////////////////////////////////////
//                            DefaultGeometry3DCreator.h                      //
////////////////////////////////////////////////////////////////////////////////

#ifndef DEFAULTGEOMETRY3DCREATOR_H
#define DEFAULTGEOMETRY3DCREATOR_H

#include "Geometry3DCreator.h"

namespace X3DTK {
namespace X3D {

/// Concrete component Creator for the geometry3D component defining the default 
/// X3D nodes.

class DefaultGeometry3DCreator : public Geometry3DCreator
{
public:
  /// Constructor.
  DefaultGeometry3DCreator();
  /// Destructor.
  virtual ~DefaultGeometry3DCreator();
  
  /// Creates a Box.
  SFNode createBox() const;
  /// Creates a Cone.
  SFNode createCone() const;
  /// Creates a Cylinder.
  SFNode createCylinder() const;
  /// Creates an IndexedFaceSet.
  SFNode createIndexedFaceSet() const;
  /// Creates a Sphere.
  SFNode createSphere() const;
};

}
}

#endif
