////////////////////////////////////////////////////////////////////////////////
//                            DefaultRenderingCreator.h                       //
////////////////////////////////////////////////////////////////////////////////

#ifndef DEFAULTRENDERINGCREATOR_H
#define DEFAULTRENDERINGCREATOR_H

#include "RenderingCreator.h"

namespace X3DTK {
namespace X3D {

/// Concrete component Creator for the Rendering component defining the default 
/// X3D nodes.

class DefaultRenderingCreator : public RenderingCreator
{
public:
  /// Constructor.
  DefaultRenderingCreator();
  /// Destructor.
  virtual ~DefaultRenderingCreator();

  /// Creates a Color.
  SFNode createColor() const;
  /// Creates a ColorRGBA.
  SFNode createColorRGBA() const;
  /// Creates a Coordinate.
  SFNode createCoordinate() const;
  /// Creates a IndexedLineSet.
  SFNode createIndexedLineSet() const;
  /// Creates a Normal.
  SFNode createNormal() const;
  /// Creates a PointSet.
  SFNode createPointSet() const;
  /// Creates a TriangleFanSet.
  SFNode createTriangleFanSet() const;
  /// Creates a TriangleSet.
  SFNode createTriangleSet() const;
  /// Creates a TriangleStripSet.
  SFNode createTriangleStripSet() const;
};

}
}

#endif
