////////////////////////////////////////////////////////////////////////////////
//                            FileValidator.h                                 //
////////////////////////////////////////////////////////////////////////////////

#ifndef FILEVALIDATOR_H
#define FILEVALIDATOR_H

#include "X3DFileValidator.h"
#include "FileValidatorGlobalVariables.h"
#include "DFS.h"

namespace X3DTK {
namespace X3D {

/// Class providing an implementation of an X3DFileValidator .

class FileValidator : public X3DFileValidator
{
public:
  /// Constructor.
  FileValidator();
  /// Destructor.
  virtual ~FileValidator();
  
  void setComponentVisitor(X3DComponentVisitor *component);
  
  virtual bool validate(SFNode N) const;
 
protected:
  DFS *dfs;
  FileValidatorGlobalVariables *globalVariables;
};

}
}

#endif
