////////////////////////////////////////////////////////////////////////////////
//                            FileValidatorGeometry3DVisitor.h                //
////////////////////////////////////////////////////////////////////////////////

#ifndef FILEVALIDATORGEOMETRY3DVISITOR_H
#define FILEVALIDATORGEOMETRY3DVISITOR_H

#include "Geometry3DVisitor.h"
#include "FileValidatorGlobalVariables.h"

namespace X3DTK {
namespace X3D {

class IndexedFaceSet;

/// Visitor for the Geometry3D component of the FileValidator module.

class FileValidatorGeometry3DVisitor : public Geometry3DVisitor
{
public:
  /// Constructor.
  FileValidatorGeometry3DVisitor();
  /// Destructor.
  virtual ~FileValidatorGeometry3DVisitor();

  /// Enters an IndexedFaceSet.
  virtual void enterIndexedFaceSet(IndexedFaceSet *I) const;

protected:
  FileValidatorGlobalVariables *globalVariables;
};

}
}

#endif
