////////////////////////////////////////////////////////////////////////////////
//                            GLBox.h                                         //
////////////////////////////////////////////////////////////////////////////////

#ifndef GLBOX_H
#define GLBOX_H

#include "X3DGLGeometry3DNode.h"

namespace X3DTK {
namespace GL {

class BoxDrawArray;

/// Class providing a implementation of the X3DGLNode corresponding to the X3DNode Box.

class Box : public X3DGeometry3DNode
{
public:
  /// Constructor.
  Box();
  /// Clones the node.
  virtual SFNode clone() const;
  /// Destructor.
  virtual ~Box();

  /// Sets the size attribute.
  void setSize(SFVec3f size);
  /// Sets the box array.
  void setBoxArray(BoxDrawArray *boxArray);

  /// Gets the size attribute.
  inline const SFVec3f &getSize() const {return _size;};
  /// Gets the box array.
  inline BoxDrawArray *getBoxArray() const {return _boxArray;};
 
  /// Updates the attributes of the node.
  virtual void update();
  /// Renders the node in an openGL context.
  virtual void render() const;  
  
protected:     
  /// Copy constructor.
  Box(const Box &B);

private:  
  /// Size attribute.
  SFVec3f _size;
  /// Box array.
  BoxDrawArray *_boxArray;
};

}
}

#endif
