////////////////////////////////////////////////////////////////////////////////
//                            GLBuilder.h                                     //
////////////////////////////////////////////////////////////////////////////////

#ifndef GLBUILDER_H
#define GLBUILDER_H

#include "X3DGLBuilder.h"
#include "GLBuilderGlobalVariables.h"
#include "DFS.h"

namespace X3DTK {
namespace X3D {

/// GLBuilder concept.

class GLBuilder : public X3DGLBuilder
{
public:
  /// Constructor.
  GLBuilder();
  /// Destructor.
  virtual ~GLBuilder();

  void setComponentVisitor(X3DComponentVisitor *component);
  
  /// Converts the X3D tree whom root is N, to an X3DGL tree.
  virtual GL::SFNode build(SFNode N);

protected:
  GLBuilderGlobalVariables *globalVariables;
  DFS *dfs;
};

}
}

#endif
