////////////////////////////////////////////////////////////////////////////////
//                            GLBuilderCoreVisitor.h                          //
////////////////////////////////////////////////////////////////////////////////

#ifndef GLBUILDERCOREVISITOR_H
#define GLBUILDERCOREVISITOR_H

#include "CoreVisitor.h"
#include "GLBuilderGlobalVariables.h"

namespace X3DTK {
namespace X3D {

class Scene;
class X3DNode;

/// Visitor for the Core component of the GLBuilder module.

class GLBuilderCoreVisitor : public CoreVisitor
{
public:
  /// Constructor.
  GLBuilderCoreVisitor();
  /// Destructor.
  virtual ~GLBuilderCoreVisitor();

  /// Enters a Scene.
  virtual void enterScene(Scene *S) const;
  /// Enters a X3DNode.
  virtual void enterX3DNode(X3DNode *N) const;

  /// Enters a Scene.
  virtual void leaveX3DNode(X3DNode *N) const;

protected:
  GLBuilderGlobalVariables *globalVariables;
};

}
}

#endif
