////////////////////////////////////////////////////////////////////////////////
//                            GLBuilderGeometry3DVisitor.h                    //
////////////////////////////////////////////////////////////////////////////////

#ifndef GLBUILDERGEOMETRY3DVISITOR_H
#define GLBUILDERGEOMETRY3DVISITOR_H

#include "Geometry3DVisitor.h"
#include "GLBuilderGlobalVariables.h"

namespace X3DTK {
namespace X3D {

class Box;
class Cone;
class Cylinder;
class IndexedFaceSet;
class Sphere;

/// Visitor for the Geometry3D component of the GLBuilder module.

class GLBuilderGeometry3DVisitor : public Geometry3DVisitor
{
public:
  /// Constructor.
  GLBuilderGeometry3DVisitor();
  /// Destructor.
  virtual ~GLBuilderGeometry3DVisitor();

  /// Enters a Box.
  virtual void enterBox(Box *B) const;
  /// Enters a Cone.
  virtual void enterCone(Cone *C) const;
  /// Enters a Cylinder.
  virtual void enterCylinder(Cylinder *C) const;
  /// Enters a IndexedFaceSet.
  virtual void enterIndexedFaceSet(IndexedFaceSet *I) const;
  /// Enters a Sphere.
  virtual void enterSphere(Sphere *S) const;

  
protected:
  GLBuilderGlobalVariables *globalVariables;
};

}
}

#endif
