////////////////////////////////////////////////////////////////////////////////
//                            GLBuilderGlobalVariables.h                      //
////////////////////////////////////////////////////////////////////////////////

#ifndef GLBUILDERGLOBALVARIABLES_H
#define GLBUILDERGLOBALVARIABLES_H

#include "GlobalVariables.h"
#include "X3DGLNode.h"

namespace X3DTK {
namespace X3D {

/// GlobalVariables for the GLBuilder module.

class GLBuilderGlobalVariables : public GlobalVariables
{
public:
  /// Constructor.
  GLBuilderGlobalVariables();
  /// Destructor.
  virtual ~GLBuilderGlobalVariables();
  /// Initializes the traversal.
  void init();
  /// Finishes the traversal.
  virtual void finish();
  
  /// Pushes the node.
  void pushNode(GL::SFNode N);
  /// Pops the node.
  void popNode();
    
  /// Gets the GLScene.
  inline GL::SFNode getRoot() const {return _root;};
  /// Gets the top of the stack.
  inline GL::SFNode getTop() const {return _nodeStack.front();};
  
private:
  GL::SFNode _root;
  GL::MFNode _nodeStack;  
};

}
}

#endif
