////////////////////////////////////////////////////////////////////////////////
//                            GLBuilderGroupingVisitor.h                      //
////////////////////////////////////////////////////////////////////////////////

#ifndef GLBUILDERGROUPINGVISITOR_H
#define GLBUILDERGROUPINGVISITOR_H

#include "GroupingVisitor.h"
#include "GLBuilderGlobalVariables.h"

namespace X3DTK {
namespace X3D {

class Group;
class StaticGroup;
class Transform;

/// Visitor for the Grouping component of the GLBuilder module.

class GLBuilderGroupingVisitor : public GroupingVisitor
{
public:
  /// Constructor.
  GLBuilderGroupingVisitor();
  /// Destructor.
  virtual ~GLBuilderGroupingVisitor();

  /// Enters a Group.
  virtual void enterGroup(Group *G) const;
  /// Enters a StaticGroup.
  virtual void enterStaticGroup(StaticGroup *S) const;
  /// Enters a Transform.
  virtual void enterTransform(Transform *T) const;

protected:
  GLBuilderGlobalVariables *globalVariables;
};

}
}

#endif
