////////////////////////////////////////////////////////////////////////////////
//                            GLBuilderRenderingVisitor.h                     //
////////////////////////////////////////////////////////////////////////////////

#ifndef GLBUILDERRENDERINGVISITOR_H
#define GLBUILDERRENDERINGVISITOR_H

#include "RenderingVisitor.h"
#include "GLBuilderGlobalVariables.h"

namespace X3DTK {
namespace X3D {

class IndexedLineSet;
class PointSet;
class TriangleFanSet;
class TriangleSet;
class TriangleStripSet;
class X3DGeometryNode;

/// Visitor for the Rendering component of the GLBuilder module.

class GLBuilderRenderingVisitor : public RenderingVisitor
{
public:
  /// Constructor.
  GLBuilderRenderingVisitor();
  /// Destructor.
  virtual ~GLBuilderRenderingVisitor();

  /// Enters a IndexedLineSet.
  virtual void enterIndexedLineSet(IndexedLineSet *I) const;
  /// Enters a PointSet.
  virtual void enterPointSet(PointSet *P) const;
  /// Enters a TriangleFanSet.
  virtual void enterTriangleFanSet(TriangleFanSet *T) const;
  /// Enters a TriangleSet.
  virtual void enterTriangleSet(TriangleSet *T) const;
  /// Enters a TriangleStripSet.
  virtual void enterTriangleStripSet(TriangleStripSet *T) const;
  
  /// Walks on an X3DGeometryNode.
  virtual bool walkOnX3DGeometryNode(X3DGeometryNode *N, SFAbstractNode child) const;
  
  

protected:
  GLBuilderGlobalVariables *globalVariables;
};

}
}

#endif
