////////////////////////////////////////////////////////////////////////////////
//                            GLBuilderShapeVisitor.h                         //
////////////////////////////////////////////////////////////////////////////////

#ifndef GLBUILDERSHAPEVISITOR_H
#define GLBUILDERSHAPEVISITOR_H

#include "ShapeVisitor.h"
#include "GLBuilderGlobalVariables.h"

namespace X3DTK {
namespace X3D {

class Appearance;
class FillProperties;
class LineProperties;
class Material;
class Shape;

/// Visitor for the Shape component of the GLBuilder module.

class GLBuilderShapeVisitor : public ShapeVisitor
{
public:
  /// Constructor.
  GLBuilderShapeVisitor();
  /// Destructor.
  virtual ~GLBuilderShapeVisitor();

  /// Enters a Appearance.
  virtual void enterAppearance(Appearance *A) const;
  /// Enters a FillProperties.
  virtual void enterFillProperties(FillProperties *F) const;
  /// Enters a LineProperties.
  virtual void enterLineProperties(LineProperties *L) const;
  /// Enters a Material.
  virtual void enterMaterial(Material *M) const;
  /// Enters a Shape.
  virtual void enterShape(Shape *S) const;

protected:
  GLBuilderGlobalVariables *globalVariables;
};

}
}

#endif
