////////////////////////////////////////////////////////////////////////////////
//                            GLDefaultDFS.h                                  //
////////////////////////////////////////////////////////////////////////////////

#ifndef GLDEFAULTDFS_H
#define GLDEFAULTDFS_H

#include "GLDFS.h"

namespace X3DTK {
namespace GL {

class DefaultDFSCoreWalker;
class DefaultDFSGeometry3DWalker;
class DefaultDFSGroupingWalker;
class DefaultDFSRenderingWalker;
class DefaultDFSShapeWalker;
class DefaultDFSTexturingWalker;

/// Class defining the a tree traversal algorithm depth first search based on default 
/// X3D nodes

class DefaultDFS : public DFS
{
public:
  /// Constructor.
  DefaultDFS();
  /// Destructor.  
  virtual ~DefaultDFS();
  
protected:
  void setComponentWalker(X3DComponentWalker *component);
  
  DefaultDFSCoreWalker *coreWalker_;
  DefaultDFSGeometry3DWalker *geometry3DWalker_;
  DefaultDFSGroupingWalker *groupingWalker_;
  DefaultDFSRenderingWalker *renderingWalker_;
  DefaultDFSShapeWalker *shapeWalker_;
  DefaultDFSTexturingWalker *texturingWalker_;        
};

}
}

#endif
