////////////////////////////////////////////////////////////////////////////////
//                            GLDefaultDFSRenderingWalker.h                   //
////////////////////////////////////////////////////////////////////////////////

#ifndef GLDEFAULTDFSRENDERINGWALKER_H
#define GLDEFAULTDFSRENDERINGWALKER_H

#include "GLDFSRenderingWalker.h"

namespace X3DTK {
namespace GL {

class X3DComposedGeometryNode;
class IndexedLineSet;
class PointSet;

/// Concrete component walker for the Rendering component.

class DefaultDFSRenderingWalker : public DFSRenderingWalker
{
public:
  /// Constructor.
  DefaultDFSRenderingWalker();
  /// Destructor.
  virtual ~DefaultDFSRenderingWalker();
  
  virtual void walkX3DComposedGeometryNode(X3DComposedGeometryNode *N) const;
  virtual void walkIndexedLineSet(IndexedLineSet *I) const;
  virtual void walkPointSet(PointSet *P) const;
};

}
}

#endif
