////////////////////////////////////////////////////////////////////////////////
//                            GLImageTexture.h                                //
////////////////////////////////////////////////////////////////////////////////

#ifndef GLIMAGETEXTURE_H
#define GLIMAGETEXTURE_H

#include "X3DGLTexture2DNode.h"

namespace X3DTK {
namespace GL {

class ImageTexture;

/// Class providing an implementation of the X3DGLNode corresponding to the X3DNode 
/// ImageTexture.

class ImageTexture : public X3DTexture2DNode
{
public:
  /// Constructor.
  ImageTexture();
  /// Clones the node.
  virtual SFNode clone() const;
  /// Destructor.
  virtual ~ImageTexture();
  
  /// Setst the texture name attribute.
  void setTexName(GLuint texName);
  /// Sets the exture transform attribute.
  void setTextureTransform(const MFFloat &textureTransform);
  
  /// Gets the texName.
  inline const GLuint &getTexName() const {return _texName;};
  /// Gets the ratioS.
  inline const MFFloat &getTextureTransform() const {return _textureTransform;};

  /// Updates the attributes of the node.
  virtual void update();
  /// Renders the node in an openGL context.
  virtual void render() const;  
  
protected:  
  /// Copy constructor.	     
  ImageTexture(const ImageTexture &I);

private:  
  /// Texture name attribute.
  GLuint _texName;
  /// Texture transform attribute.
  MFFloat _textureTransform;
};

}
}

#endif
