////////////////////////////////////////////////////////////////////////////////
//                            GLRenderer.h                                    //
////////////////////////////////////////////////////////////////////////////////

#ifndef GLRENDERER_H
#define GLRENDERER_H

#include "X3DGLRenderer.h"
#include "GLRendererGlobalVariables.h"
#include "GLDFS.h"

namespace X3DTK {
namespace GL {

/// GLRenderer module.

class Renderer : public X3DRenderer
{
public:
  /// Constructor.
  Renderer();
  /// Destructor.
  virtual ~Renderer();
  
  void setComponentVisitor(X3DComponentVisitor *component);
  
  /// Renders a GLScene.
  virtual void render(X3DNode *N) const;

protected:
  RendererGlobalVariables *globalVariables;
  DFS *dfs;
};

}
}

#endif
