////////////////////////////////////////////////////////////////////////////////
//                            GLRendererGLGroupingVisitor.h                   //
////////////////////////////////////////////////////////////////////////////////

#ifndef GLRENDERERGLGROUPINGVISITOR_H
#define GLRENDERERGLGROUPINGVISITOR_H

#include "GLGroupingVisitor.h"
#include "GLRendererGlobalVariables.h"

namespace X3DTK {
namespace GL {

class Group;
class StaticGroup;
class Transform;

/// Visitor for the GLGrouping component of the GLRenderer module.

class RendererGroupingVisitor : public GroupingVisitor
{
public:
  /// Constructor.
  RendererGroupingVisitor();
  /// Destructor.
  virtual ~RendererGroupingVisitor();

  /// Leaves a GLTransform.
  virtual void leaveTransform(Transform *G) const;

protected:
  RendererGlobalVariables *globalVariables;
};

}
}

#endif
