////////////////////////////////////////////////////////////////////////////////
//                            GLScene.h                                       //
////////////////////////////////////////////////////////////////////////////////

#ifndef GLSCENE_H
#define GLSCENE_H

#include "X3DGLGroupingNode.h"

namespace X3DTK {
namespace GL {

/// Base class of the Core component. A set of X3DGLNode represents a scene graph
/// related with the X3D scene graph. Each X3DNode able to be drawn directly has 
/// its X3DGLNode correspondence. For example X3DIndexedFaceSet is related with 
/// GLIndexedFaceSet, whereas Coordinate has no X3DGLNode correspondent. 

class Scene : public X3DGroupingNode
{
public:
  /// Constructor.
  Scene();
  /// Clones the node.
  virtual SFNode clone() const;
  /// Virtual destructor.
  virtual ~Scene();

protected:
  /// Copy constructor.
  Scene(const Scene &S);
};

}
}

#endif
