////////////////////////////////////////////////////////////////////////////////
//                            GLStaticGroup.h                                 //
//////////////////////////////////////////////////////////////////////////////// 

#ifndef GLSTATICGROUP_H
#define GLSTATICGROUP_H

#include "X3DGLChildNode.h"

namespace X3DTK {
namespace GL {

/// Class providing a implementation of the X3DGLNode corresponding to the X3DNode 
/// StaticGroup.

class StaticGroup : public X3DChildNode
{
public:
  /// Constructor.
  StaticGroup();
  /// Clones the node.
  virtual SFNode clone() const;
  /// Destructor.
  virtual ~StaticGroup();
  
  /// Adds a child to the Children attribute. Return TRUE if succeeds.
  virtual bool addChild(const SFAbstractNode &N);
  /// Sets the child. Behaves like addChild.
  virtual bool setChild(const SFAbstractNode &N);
  /// Removes the child. Return TRUE if succeeds.
  virtual bool removeChild(const SFAbstractNode &N);
 
  /// Sets the children.
  void setChildren(const MFNode &children);
  
  /// Gets the Children attribute.
  inline MFNode getChildren() const {return _children;};

protected:  
  /// Copy constructor.		
  StaticGroup(const StaticGroup &G);
 
private:   
  /// Children attribute.
  MFNode _children;
};

}
}

#endif
