////////////////////////////////////////////////////////////////////////////////
//                            GLTransform.h                                   //
////////////////////////////////////////////////////////////////////////////////

#ifndef GLTRANSFORM_H
#define GLTRANSFORM_H

#include "X3DGLGroupingNode.h"

#include <vector>

namespace X3DTK {
namespace GL {

/// Class providing a implementation of the X3DGLNode corresponding to the X3DNode 
/// Transform.

class Transform : public X3DGroupingNode
{
public:  
  /// Constructor.
  Transform();
  /// Clones the node.
  virtual SFNode clone() const;
  /// Destructor.
  virtual ~Transform();

  /// Sets the transform matrix attribute.
  void setTransformMatrix(const MFFloat &transformMatrix);
  
  /// Gets the transform matrix attribute.
  inline const MFFloat &getTransformMatrix() const {return _transformMatrix;};
  
  /// Updates the attributes of the node.
  virtual void update();
  /// Transforms the coordinates.
  virtual void render() const;
  
protected:
  /// Copy constructor.	             
  Transform(const Transform &T);

private:  
  /// Transform matrix attribute.
  MFFloat _transformMatrix;
};

}
}

#endif
