////////////////////////////////////////////////////////////////////////////////
//                            GLUpdater.h                                     //
////////////////////////////////////////////////////////////////////////////////

#ifndef GLUPDATER_H
#define GLUPDATER_H

#include "X3DGLUpdater.h"
#include "GLUpdaterGlobalVariables.h"
#include "X3DGLNode.h"

namespace X3DTK {
namespace GL {

class DFS;

/// GLUpdater module.

class Updater : public X3DUpdater
{
public:
  /// Constructor.
  Updater();
  /// Destructor.
  virtual ~Updater();
  
  /// Sets the component visitor.
  void setComponentVisitor(X3DComponentVisitor *component);
  
  /// Updates the GLScene.
  virtual void update(X3DNode *N);

protected:
  UpdaterGlobalVariables *globalVariables;
  DFS *dfs;
};

}
}

#endif
