////////////////////////////////////////////////////////////////////////////////
//                            Group.h                                         //
//////////////////////////////////////////////////////////////////////////////// 

#ifndef GROUP_H
#define GROUP_H

#include "X3DTypes.h"
#include "X3DGroupingNode.h"
#include "X3DBoundedObject.h"

namespace X3DTK {
namespace X3D {

/// Class of the <a href="../../doc/X3DSpecs/Part01/components/group.html">
/// Grouping component</a> defining a Group
/// (<a href="../../doc/X3DSpecs/Part01/components/grouping.html#Group">
/// documentation</a>).

class Group : public X3DGroupingNode, public X3DBoundedObject
{
public:
  /// Constructor.
  Group();
  /// Constructs a Group from its attributes.
  Group(const SFVec3f &bboxCenter, 
	const SFVec3f &bboxSize);
  /// Clones the node.
  virtual SFNode clone() const;
  /// Destructor.
  virtual ~Group();
  
  /// Loads the attributes from a FileElement.
  virtual void load(const X3DFileElement *element);
  /// Writes the attributes of the node.
  virtual SFString write() const;

protected: 
  /// Copy constructor.	
  Group(const Group &G);
};

}
}

#endif
