////////////////////////////////////////////////////////////////////////////////
//                            Image.h                                         //
////////////////////////////////////////////////////////////////////////////////

#ifndef IMAGE_H
#define IMAGE_H

#include "X3DImageType.h"

namespace X3DTK {

class Image
{
public:
  Image();
  Image(const char *fileName);
  ~Image();
  
  bool load(const char *fileName);  
  //void adaptToGLSize();
  
  inline unsigned short getWidth() const {return (_imageType != 0 ? _imageType->getWidth() : 0);};
  inline unsigned short getHeight() const {return (_imageType != 0 ? _imageType->getHeight() : 0);};
  inline int getPixelFormat() const {return (_imageType != 0 ? _imageType->getPixelFormat() : 0);};
  inline unsigned char* getData() const {return _imageType->getData();};
  
private:
  X3DImageType *_imageType;
};

}

#endif
