////////////////////////////////////////////////////////////////////////////////
//                            ImageTexture.h                                  //
////////////////////////////////////////////////////////////////////////////////

#ifndef IMAGETEXTURE_H
#define IMAGETEXTURE_H

#include "X3DTexture2DNode.h"

namespace X3DTK {
namespace X3D {

/// Class of the <a href="../../doc/X3DSpecs/Part01/components/texturing.html">
/// Texturing component</a> defining an ImageTexture
/// (<a href="../../doc/X3DSpecs/Part01/components/texturing.html#ImageTexture">
/// documentation</a>).

class ImageTexture : public X3DTexture2DNode
{
public:  
  /// Constructor.
  ImageTexture();
  /// Clones the node.
  virtual SFNode clone() const;
  /// Virtual destructor.
  virtual ~ImageTexture();
  
  /// Sets the url attribute.
  void setUrl(const MFString &url);

  /// Gets the url attribute.
  inline const MFString &getUrl() const {return _url;};
    
  /// Loads the attributes from a FileElement.
  virtual void load(const X3DFileElement *element);
  /// Writes the attributes of the node.
  virtual SFString write() const;

protected:  
  /// Copy constructor.	
  ImageTexture(const ImageTexture &N);

private:  
  /// url.
  MFString _url;  
};

}
}

#endif
