////////////////////////////////////////////////////////////////////////////////
//                            MemReleaser.h                                   //
////////////////////////////////////////////////////////////////////////////////

#ifndef MEMRELEASER_H
#define MEMRELEASER_H

#include "X3DMemReleaser.h"
#include "MemReleaserGlobalVariables.h"

#include "DFS.h"

namespace X3DTK {

/// MemReleaser module.

class MemReleaser : public X3DMemReleaser
{
public:
  /// Constructor.
  MemReleaser(X3DTTAlgorithm *algo = 0);
  /// Destructor.
  virtual ~MemReleaser();
  
  void setComponentVisitor(X3DComponentVisitor *component);
  
  virtual void release(SFAbstractNode N) const;

protected:
  MemReleaserGlobalVariables *globalVariables;
  bool defaultDFSUSE;
  X3DTTAlgorithm *dfs;
};

}

#endif
