////////////////////////////////////////////////////////////////////////////////
//                            MemReleaserAbstractVisitor.h                    //
////////////////////////////////////////////////////////////////////////////////

#ifndef MEMRELEASERAbstractVISITOR_H
#define MEMRELEASERAbstractVISITOR_H

#include "AbstractVisitor.h"
#include "MemReleaserGlobalVariables.h"

namespace X3DTK {

/// Visitor for the Abstract component of the MemReleaser module.

class MemReleaserAbstractVisitor : public AbstractVisitor
{
public:
  /// Constructor.
  MemReleaserAbstractVisitor();
  /// Destructor.
  virtual ~MemReleaserAbstractVisitor();

  /// Enters a X3DAbstractNode.
  virtual void enterX3DAbstractNode(X3DAbstractNode *N) const;

  /// Walks on a X3DAbstractNode.
  virtual bool walkOnX3DAbstractNode(X3DAbstractNode *N, SFAbstractNode child) const;
  
  /// Leaves a X3DAbstractNode.
  virtual void leaveX3DAbstractNode(X3DAbstractNode *N) const;

protected:
  MemReleaserGlobalVariables *globalVariables;
};

}

#endif
