////////////////////////////////////////////////////////////////////////////////
//                            MeshAlgoFunctions.h                             //
////////////////////////////////////////////////////////////////////////////////

#ifndef MESHALGOFUNCTIONS_H
#define MESHALGOFUNCTIONS_H

namespace X3DTK {
namespace Mesh {

/// Start function of the algorithm of building the mesh structure. This method has to
/// be specialized for a particular Mesh.

template<class T, class M>
void start(T *, M *) {};

/// Processes a new face.
template<class T, class F, class M>
void processNewFace(T *, F *, M *) {};

/// End function of the algorithm of building the mesh structure. This method has to
/// be specialized for a particular Mesh.

template<class T, class M>
void end(T *, M *) {};

}
}

#endif
