////////////////////////////////////////////////////////////////////////////////
//                            MeshDFS.h                                       //
////////////////////////////////////////////////////////////////////////////////

#ifndef MESHDFS_H
#define MESHDFS_H

#include "X3DTTAlgorithm.h"

namespace X3DTK {
namespace Mesh {

class DFSCoreWalker;
class DFSGeometry3DWalker;
class DFSGroupingWalker;
class DFSRenderingWalker;
class DFSShapeWalker;
class DFSTexturingWalker;

/// Class defining the tree traversal algorithm depth first search based on  
/// X3D nodes.

class DFS : public X3DTTAlgorithm
{
public:
  /// Constructor.
  DFS();
  /// Destructor.  
  virtual ~DFS();
  
protected:
  void setComponentWalker(X3DComponentWalker *component);
  
  /// CoreWalker.
  DFSCoreWalker *coreWalker;
  /// CoreWalker.
  DFSGeometry3DWalker *geometry3DWalker;
  /// Geometry3DWalker.
  DFSGroupingWalker *groupingWalker;
  /// GroupingWalker.
  DFSRenderingWalker *renderingWalker;
  /// RenderingWalker.
  DFSShapeWalker *shapeWalker;
  /// TexturingWalker.
  DFSTexturingWalker *texturingWalker;        
};

}
}

#endif
