////////////////////////////////////////////////////////////////////////////////
//                            MeshTransform.h                                 //
////////////////////////////////////////////////////////////////////////////////

#ifndef MESHTRANSFORM_H
#define MESHTRANSFORM_H

#include "X3DMeshGroupingNode.h"

namespace X3DTK {
namespace Mesh {

/// Class providing a Transform node for the Mesh graph scene.

class Transform : public X3DGroupingNode
{
public:
  /// Constructor.
  Transform();
  /// Clones the node.
  virtual SFNode clone() const;
  /// Virtual destructor.
  virtual ~Transform();
  
  /// Sets the transformation.
  void setTransform(const SFMatrix34f &M);
  
  /// Gets the transformation.
  const SFMatrix34f &getTransform() const;
  
protected:
  /// Copy constructor.
  Transform(const Transform &T);
  
private:
  SFMatrix34f _transform;  
};

}
}

#endif
