////////////////////////////////////////////////////////////////////////////////
//                            QFileElement.h                                  //
////////////////////////////////////////////////////////////////////////////////

#ifndef QFILEELEMENT_H
#define QFILEELEMENT_H

#include "X3DFileElement.h"

namespace X3DTK {

class QFileElementImplementation;

/// Class providing an implementation of X3DFileElement based upon Xerces.

class QFileElement : public X3DFileElement
{
  friend class QSAX2X3DHandler;
public:
  /// Gets the name.
  SFString getName() const;
  /// Gets the attribute at the index i.
  SFString getAttribute(int i) const;
  /// Gets the index of the attribute. Returns -1 if doesn't exist.
  int getIndexAttribute(const SFString &attribute) const;
  
private:
  QFileElementImplementation *impl;
  QFileElement(const SFString &name, const void *const attributes);
  ~QFileElement();  
};

}

#endif
