////////////////////////////////////////////////////////////////////////////////
//                            QLoader.h                                       //
////////////////////////////////////////////////////////////////////////////////

#ifndef QLOADER_H
#define QLOADER_H

#include "X3DLoader.h"

namespace X3DTK {

class QLoaderImplementation;
class NodeCreationProxy;

/// X3D file loader based on a Q SAX2 reader.

class QLoader : public X3DLoader
{
public:
  /// Constructor.
  QLoader(NodeCreationProxy *nodeCreationProxy);
  /// Destructor.
  ~QLoader();

protected:  
  /// Loads a scene from the file.
  X3D::Scene *loadFile(const char *file, bool fileValidation = false) const;
  
private:
  QLoaderImplementation *_impl;
};

}

#endif
