////////////////////////////////////////////////////////////////////////////////
//                            Scene.h                                         //
////////////////////////////////////////////////////////////////////////////////

#ifndef SCENE_H
#define SCENE_H

#include "X3DTypes.h"
#include "X3DGroupingNode.h"
#include "X3DBoundedObject.h"

namespace X3DTK {
namespace X3D {

/// Class providing a Scene, root node of an X3D scene graph.

class Scene : public X3DGroupingNode, public X3DBoundedObject
{
public:
  /// Constructor.
  Scene();
  /// Clones the node.
  virtual SFNode clone() const;
  /// Destructor.
  virtual ~Scene();

  /// Sets the filename of the Scene.
  void setFileName(const SFString &file);
 
  /// Gets the name of the file.
  inline SFString getFileName() const {return _fileName;};

  /// Loads the attributes from a FileElement.
  virtual void load(const X3DFileElement *element);
  /// Writes the attributes of the node.
  virtual SFString write() const;

protected:
  /// Copy constructor.
  Scene(const Scene &S);

private:  
  /// File attribute.
  SFString _fileName;
};

}
}

#endif
