////////////////////////////////////////////////////////////////////////////////
//                            SceneSaver.h                                    //
////////////////////////////////////////////////////////////////////////////////

#ifndef SCENESAVER_H
#define SCENESAVER_H

#include "X3DSceneSaver.h"
#include "SceneSaverGlobalVariables.h"
#include "DFS.h"

namespace X3DTK {
namespace X3D {

class Scene;

/// SceneSaver module.

class SceneSaver : public X3DSceneSaver
{
public:
  /// Constructor.
  SceneSaver(DFS *dfs = 0);
  /// Destructor.
  virtual ~SceneSaver();
  
  void setComponentVisitor(X3DComponentVisitor *component);
  
  /// Writes the content of S in file.
  virtual void saveAs(Scene *S, const SFString &fileName) const;
  /// Writes the content of S in file.
  virtual void save(Scene *S) const;

  void *getDFS() {return (void *)dfs;};

protected:
  SceneSaverGlobalVariables *globalVariables;
  bool defaultDFSUSE;
  DFS *dfs;
};

}
}

#endif
