////////////////////////////////////////////////////////////////////////////////
//                            SceneSaverCoreVisitor.h                         //
////////////////////////////////////////////////////////////////////////////////

#ifndef SCENESAVERCOREVISITOR_H
#define SCENESAVERCOREVISITOR_H

#include "CoreVisitor.h"
#include "SceneSaverGlobalVariables.h"

namespace X3DTK {
namespace X3D {

class Scene;
class X3DNode;

/// Visitor for the Core component of the SceneSaver module.

class SceneSaverCoreVisitor : public CoreVisitor
{
public:
  /// Constructor.
  SceneSaverCoreVisitor();
  /// Destructor.
  virtual ~SceneSaverCoreVisitor();

  /// Enters a X3DNode.
  virtual void enterX3DNode(X3DNode *N) const;


  /// Walks on a X3DNode.
  virtual bool walkOnX3DNode(X3DNode *N, SFAbstractNode Child) const;

  /// Enters a X3DNode.
  virtual void leaveX3DNode(X3DNode *N) const;

protected:
  SceneSaverGlobalVariables *globalVariables;
};

}
}

#endif
