////////////////////////////////////////////////////////////////////////////////
//                            TemplateMeshBuilderCoreVisitor.h                //
////////////////////////////////////////////////////////////////////////////////

#ifndef TEMPLATEMESHBUILDERCOREVISITOR_H
#define TEMPLATEMESHBUILDERCOREVISITOR_H

#include "CoreVisitor.h"
#include "TemplateMeshBuilderGlobalVariables.h"

namespace X3DTK {
namespace X3D {

class Scene;

/// Visitor for the Core component of the TemplateMeshBuilder processor.

class TemplateMeshBuilderCoreVisitor : public CoreVisitor
{
public:
  /// Constructor.
  TemplateMeshBuilderCoreVisitor();
  
  /// Destructor.
  virtual ~TemplateMeshBuilderCoreVisitor();

  /// Enters a Scene.
  virtual void enterScene(Scene *S) const;
  
  /// Enters a Scene.
  virtual void leaveX3DNode(X3DNode *N) const;

protected:
  TemplateMeshBuilderGlobalVariables *globalVariables;
};

}
}

#endif
