////////////////////////////////////////////////////////////////////////////////
//                            TemplateMeshBuilderGlobalVariables.h            //
////////////////////////////////////////////////////////////////////////////////

#ifndef TEMPLATEMESHBUILDERGLOBALVARIABLES_H
#define TEMPLATEMESHBUILDERGLOBALVARIABLES_H

#include "GlobalVariables.h"
#include "X3DMeshNode.h"

namespace X3DTK {
namespace X3D {

/// GlobalVariables for the TemplateMeshBuilder processor.

class TemplateMeshBuilderGlobalVariables : public GlobalVariables
{
public:
  /// Constructor.
  TemplateMeshBuilderGlobalVariables();
  /// Destructor.
  virtual ~TemplateMeshBuilderGlobalVariables();
  /// Initializes the traversal.
  void init();
  /// Finishes the traversal.
  virtual void finish();
  
  /// Pushes the node.
  void pushNode(Mesh::SFNode N);
  /// Pops the node.
  void popNode();
    
  /// Gets the GLScene.
  inline Mesh::SFNode getRoot() const {return _root;};
  /// Gets the top of the stack.
  inline Mesh::SFNode getTop() const {return _nodeStack.front();};
  
private:
  Mesh::SFNode _root;
  Mesh::MFNode _nodeStack;  
};

}
}

#endif
