////////////////////////////////////////////////////////////////////////////////
//                            TemplateMeshBuilderGroupingVisitor.h            //
////////////////////////////////////////////////////////////////////////////////

#ifndef TEMPLATEMESHBUILDERGROUPINGVISITOR_H
#define TEMPLATEMESHBUILDERGROUPINGVISITOR_H

#include "GroupingVisitor.h"
#include "TemplateMeshBuilderGlobalVariables.h"

namespace X3DTK {
namespace X3D {

class Group;
class StaticGroup;
class Transform;

/// Visitor for the Grouping component of the TemplateMeshBuilder module.

class TemplateMeshBuilderGroupingVisitor : public GroupingVisitor
{
public:
  /// Constructor.
  TemplateMeshBuilderGroupingVisitor();
  /// Destructor.
  virtual ~TemplateMeshBuilderGroupingVisitor();

  /// Enters a Group.
  virtual void enterGroup(Group *G) const;
  /// Enters a StaticGroup.
  virtual void enterStaticGroup(StaticGroup *S) const;
  /// Enters a Transform.
  virtual void enterTransform(Transform *T) const;

protected:
  TemplateMeshBuilderGlobalVariables *globalVariables;
};

}
}

#endif
