////////////////////////////////////////////////////////////////////////////////
//                            TemplateMeshBuilderRenderingVisitor.h           //
////////////////////////////////////////////////////////////////////////////////

#ifndef TEMPLATEMESHBUILDERRENDERINGVISITOR_H
#define TEMPLATEMESHBUILDERRENDERINGVISITOR_H

#include "RenderingVisitor.h"
#include "TemplateMeshBuilderGlobalVariables.h"

namespace X3DTK {
namespace X3D {

class X3DGeometryNode;

/// Visitor for the Rendering component of the TemplateMeshBuilder module.

class TemplateMeshBuilderRenderingVisitor : public RenderingVisitor
{
public:
  /// Constructor.
  TemplateMeshBuilderRenderingVisitor();
  /// Destructor.
  virtual ~TemplateMeshBuilderRenderingVisitor();

  /// Walks on an X3DGeometryNode.
  bool walkOnX3DGeometryNode(X3DGeometryNode *N, SFAbstractNode child) const;

protected:
  TemplateMeshBuilderGlobalVariables *globalVariables;
};

}
}

#endif
