////////////////////////////////////////////////////////////////////////////////
//                            TemplateMeshBuilderShapeVisitor.h               //
////////////////////////////////////////////////////////////////////////////////

#ifndef TEMPLATEMESHBUILDERSHAPEVISITOR_H
#define TEMPLATEMESHBUILDERSHAPEVISITOR_H

#include "ShapeVisitor.h"
#include "TemplateMeshBuilderGlobalVariables.h"

namespace X3DTK {
namespace X3D {

class Shape;

/// Visitor for the Shape component of the TemplateMeshBuilder module.

class TemplateMeshBuilderShapeVisitor : public ShapeVisitor
{
public:
  /// Constructor.
  TemplateMeshBuilderShapeVisitor();
  /// Destructor.
  virtual ~TemplateMeshBuilderShapeVisitor();

  /// Enters a Shape.
  virtual void enterShape(Shape *S) const;

  /// Walks on a Shape.
  virtual bool walkOnShape(Shape *S, SFAbstractNode child) const;

  /// Leaves a Shape.
  virtual void leaveShape(Shape *S) const;

protected:
  TemplateMeshBuilderGlobalVariables *globalVariables;
};

}
}

#endif
