////////////////////////////////////////////////////////////////////////////////
//                            TextureCoordinate.h                             //
////////////////////////////////////////////////////////////////////////////////

#ifndef TEXTURECOORDINATE_H
#define TEXTURECOORDINATE_H

#include "X3DTextureCoordinateNode.h"

namespace X3DTK {
namespace X3D {

/// Class of the <a href="../../doc/X3DSpecs/Part01/components/texturing.html">
/// Texturing component</a> defining a TextureCoordinate.
/// (<a href="../../doc/X3DSpecs/Part01/components/texturing.html#TextureCoordinate">
/// documentation</a>).

class TextureCoordinate : public X3DTextureCoordinateNode
{
public:  
  /// Constructor.
  TextureCoordinate();
  /// Clones the node.
  virtual SFNode clone() const;
  /// Virtual destructor.
  virtual ~TextureCoordinate();

protected:
  /// Copy constructor.	
  TextureCoordinate(const TextureCoordinate &N);
};

}
}

#endif
