////////////////////////////////////////////////////////////////////////////////
//                            WalkOnFunction.h                                //
////////////////////////////////////////////////////////////////////////////////

#ifndef WALKONFUNCTION_H
#define WALKONFUNCTION_H

#include "X3DActiveFunction.h"
#include "X3DTypes.h"

namespace X3DTK {

/// Abstract class defining the concept of walk on function implemented by a functor.

class WalkOnFunction : public X3DActiveFunction
{
public:
  /// Constructor.
  WalkOnFunction(const ptrToWalkOnFunction walkon, const X3DComponentVisitor *component);
  /// Destructor.
  ~WalkOnFunction();
  
  /// Enter the node.
  inline bool walkOn(SFAbstractNode N, SFAbstractNode child) const {return (component_->*ptr2walkon_)(N, child);};
  
private:
  const ptrToWalkOnFunction ptr2walkon_;
  const X3DComponentVisitor *component_;
};

}

#endif
