////////////////////////////////////////////////////////////////////////////////
//                            WalkingFunction.h                               //
////////////////////////////////////////////////////////////////////////////////

#ifndef WALKINGFUNCTION_H
#define WALKINGFUNCTION_H

#include "X3DActiveFunction.h"
#include "X3DTypes.h"

namespace X3DTK {

/// Concrete class defining the concept of walking function implemented by a functor.

class WalkingFunction : public X3DActiveFunction
{
public:
  /// Constructor.
  WalkingFunction(const ptrToWalkingFunction f, const X3DComponentWalker *component);
  /// Destructor.
  ~WalkingFunction();
  
  /// Walks the node.
  inline void walk(const SFAbstractNode N) const {(component_->*ptr2function_)(N);};

private:
  const ptrToWalkingFunction ptr2function_;
  const X3DComponentWalker *component_;
};

}

#endif
