////////////////////////////////////////////////////////////////////////////////
//                            WorldCoordTranslator.h                          //
////////////////////////////////////////////////////////////////////////////////

#ifndef WORLDCOORDTRANSLATOR_H
#define WORLDCOORDTRANSLATOR_H

#include "X3DTTAlgorithm.h"
#include "WorldCoordTranslatorGlobalVariables.h"
#include "DFS.h"

namespace X3DTK {
namespace X3D {

/// X3DWorldCoordTranslator concept.

class WorldCoordTranslator : public X3DTTAlgorithm
{
public:
  /// Constructor.
  WorldCoordTranslator();
  /// Destructor.
  virtual ~WorldCoordTranslator();
  
  void setComponentVisitor(X3DComponentVisitor *component);
  
  virtual void translate(SFNode N);
 
protected:
  WorldCoordTranslatorGlobalVariables *globalVariables;
  DFS *dfs;
};

}
}

#endif
