////////////////////////////////////////////////////////////////////////////////
//                            WorldCoordTranslatorGlobalVariables.h           //
////////////////////////////////////////////////////////////////////////////////

#ifndef WORLDCOORDTRANSLATORGLOBALVARIABLES_H
#define WORLDCOORDTRANSLATORGLOBALVARIABLES_H

#include "GlobalVariables.h"

#include <list>

namespace X3DTK {
namespace X3D {

/// GlobalVariables for the WorldCoordTranslator module.

class WorldCoordTranslatorGlobalVariables : public GlobalVariables
{
public:
  /// Constructor.
  WorldCoordTranslatorGlobalVariables();
  /// Destructor.
  virtual ~WorldCoordTranslatorGlobalVariables();

  /// Initializes the traversal.
  void init();
  /// Finishes the traversal.
  void finish();

  /// Pushes the transformation matrix.
  void pushMatrix(const SFMatrix34f &transformation);  
  
  /// Pops the transformation matrix.
  void popMatrix();
  
  /// Gets the current transformation matrix.
  SFMatrix34f getMatrix() const {return _matrixStack.front();};

private: 
  std::list<SFMatrix34f> _matrixStack;
};

}
}

#endif
