////////////////////////////////////////////////////////////////////////////////
//                            WorldCoordTranslatorGroupingVisitor.h           //
////////////////////////////////////////////////////////////////////////////////

#ifndef WORLDCOORDTRANSLATORGROUPINGVISITOR_H
#define WORLDCOORDTRANSLATORGROUPINGVISITOR_H

#include "GroupingVisitor.h"
#include "WorldCoordTranslatorGlobalVariables.h"

namespace X3DTK {
namespace X3D {

class Transform;

/// Visitor for the Grouping component of the WorldCoordTranslator module.

class WorldCoordTranslatorGroupingVisitor : public GroupingVisitor
{
public:
  /// Constructor.
  WorldCoordTranslatorGroupingVisitor();
  /// Destructor.
  virtual ~WorldCoordTranslatorGroupingVisitor();

  /// Enters a Transform.
  virtual void enterTransform(Transform *T) const;
  /// Enters a Transform.
  virtual void leaveTransform(Transform *T) const;

protected:
  WorldCoordTranslatorGlobalVariables *globalVariables;
};

}
}

#endif
