////////////////////////////////////////////////////////////////////////////////
//                            WorldCoordTranslatorRenderingVisitor.h          //
////////////////////////////////////////////////////////////////////////////////

#ifndef WORLDCOORDTRANSLATORRENDERINGVISITOR_H
#define WORLDCOORDTRANSLATORRENDERINGVISITOR_H

#include "RenderingVisitor.h"
#include "WorldCoordTranslatorGlobalVariables.h"

namespace X3DTK {
namespace X3D {

class Coordinate;
class Normal;
class X3DGeometryNode;

/// Visitor for the Rendering component of the WorldCoordTranslator module.

class WorldCoordTranslatorRenderingVisitor : public RenderingVisitor
{
public:
  /// Constructor.
  WorldCoordTranslatorRenderingVisitor();
  /// Destructor.
  virtual ~WorldCoordTranslatorRenderingVisitor();

  /// Enters a Coordinate.
  virtual void enterCoordinate(Coordinate *C) const;

  /// Enters a Normal.
  virtual void enterNormal(Normal *N) const;

protected:
  WorldCoordTranslatorGlobalVariables *globalVariables;
};

}
}

#endif
