////////////////////////////////////////////////////////////////////////////////
//                            X3DActiveFunction.h                             //
////////////////////////////////////////////////////////////////////////////////

#ifndef X3DACTIVEFUNCTION_H
#define X3DACTIVEFUNCTION_H

#include "X3DFunction.h"

namespace X3DTK {

/// Abstract class defining the concept of active function.

class X3DActiveFunction : public X3DFunction
{
public:
  /// Constructor.
  X3DActiveFunction();
  /// Destructor.
  virtual ~X3DActiveFunction() = 0;
  
  /// Returns TRUE if the function is active
  inline bool isActive() const {return active_;};
  /// Sets the function active.
  inline void setActive() {active_ = true;};
  /// Sets the function inactive.  
  inline void setInactive() {active_ = false;};
  
private:
  bool active_;    
};

}

#endif
