////////////////////////////////////////////////////////////////////////////////
//                            X3DAppearanceChildNode.h                        //
//////////////////////////////////////////////////////////////////////////////// 

#ifndef X3DAPPEARANCECHILDNODE_H
#define X3DAPPEARANCECHILDNODE_H

#include "X3DNode.h"

namespace X3DTK {
namespace X3D {

/// Base class of the <a href="../../doc/X3DSpecs/Part01/components/shape.html">Shape 
/// component</a> defining an X3DAppearanceChildNode
/// (<a href="../../doc/X3DSpecs/Part01/components/Shape.html#X3DAppearanceChildNode">
/// documentation</a>).

class X3DAppearanceChildNode : public X3DNode
{
public:
  /// Constructor.
  X3DAppearanceChildNode();
  /// Clones the node.
  virtual SFNode clone() const;
  /// Virtual destructor.
  virtual ~X3DAppearanceChildNode();

protected:
  /// Copy constructor.
  X3DAppearanceChildNode(const X3DAppearanceChildNode &N);
};

}
}

#endif
