////////////////////////////////////////////////////////////////////////////////
//                            X3DChildNode.h                                  //
//////////////////////////////////////////////////////////////////////////////// 

#ifndef X3DCHILDNODE_H
#define X3DCHILDNODE_H

#include "X3DNode.h"

namespace X3DTK {
namespace X3D {

/// Base class of the <a href="../../doc/X3DSpecs/Part01/components/group.html">
/// Grouping component</a> defining an X3DChildNode
/// (<a href="../../doc/X3DSpecs/Part01/components/grouping.html#X3DChildNode">
/// documentation</a>).

class X3DChildNode : public X3DNode
{
public:
  /// Constructor.
  X3DChildNode();
  /// Clones the node.
  virtual SFNode clone() const;
  /// Virtual destructor.
  virtual ~X3DChildNode();

protected:
  /// Copy constructor.		  
  X3DChildNode(const X3DChildNode &N);
};

}
}

#endif
