////////////////////////////////////////////////////////////////////////////////
//                            X3DCoordinateNode.h                            //
////////////////////////////////////////////////////////////////////////////////

#ifndef X3DCOORDINATENODE_H
#define X3DCOORDINATENODE_H

#include "X3DGeometricPropertyNode.h"

namespace X3DTK {
namespace X3D {

/// Base class of the <a href="../../doc/X3DSpecs/Part01/components/rendering.html">
/// Rendering component</a> defining an X3DCoordinateNode
/// (<a href="../../doc/X3DSpecs/Part01/components/rendering.html#X3DCoordinateNode">
/// documentation</a>).

class X3DCoordinateNode : public X3DGeometricPropertyNode
{
public:  
  /// Constructor.
  X3DCoordinateNode();
  /// Clones the node.
  virtual SFNode clone() const;
  /// Virtual destructor.
  virtual ~X3DCoordinateNode();

protected:
  /// Constructs an X3DCoordinateNode from its attributes.
  X3DCoordinateNode(const X3DCoordinateNode &N);
};

}
}

#endif
