////////////////////////////////////////////////////////////////////////////////
//                            X3DGLBuilder.h                                  //
////////////////////////////////////////////////////////////////////////////////

#ifndef X3DGLBUILDER_H
#define X3DGLBUILDER_H

#include "X3DOnePassProcessor.h"
#include "X3DNode.h"

namespace X3DTK {

namespace GL {

class Scene;

}

namespace X3D {

/// X3DGLBuilder concept.

class X3DGLBuilder : public X3DOnePassProcessor
{
public:
  /// Constructor.
  X3DGLBuilder();
  /// Destructor.
  virtual ~X3DGLBuilder() = 0;

  /// Converts N to a GL node.
  virtual GL::SFNode build(SFNode N) = 0;
  /// Returns the GL::Scene converted from S.
  GL::Scene *build(Scene *S);
};

}
}

#endif
