////////////////////////////////////////////////////////////////////////////////
//                            X3DGLGroupingNode.h                             //
//////////////////////////////////////////////////////////////////////////////// 

#ifndef X3DGLGROUPINGNODE_H
#define X3DGLGROUPINGNODE_H

#include "X3DGLChildNode.h"

namespace X3DTK {
namespace GL {

/// Class providing an interface for the equivalent of the X3DGroupingNode in the X3DGL tree.

class X3DGroupingNode : public X3DChildNode
{
public:
  /// Constructor.
  X3DGroupingNode();
  /// Clones the node.
  virtual SFNode clone() const;
  /// Virtual destructor.
  virtual ~X3DGroupingNode();

  /// Adds a child to the Children attribute. Return TRUE if succeeds.
  virtual bool addChild(const SFAbstractNode &N);
  /// Sets the child. Behaves like addChild.
  virtual bool setChild(const SFAbstractNode &N);
  /// Removes the child. Return TRUE if succeeds.
  virtual bool removeChild(const SFAbstractNode &N);
  
  /// Sets the children.
  void setChildren(const MFNode &children);
  
  /// Gets the Children attribute.
  inline MFNode getChildren() const {return _children;};

protected:
  /// Copy constructor.		  
  X3DGroupingNode(const X3DGroupingNode &N);

private:  
  /// Children attribute.
  MFNode _children;
};

}
}

#endif
