////////////////////////////////////////////////////////////////////////////////
//                            X3DGeometricPropertyNode.h                     //
////////////////////////////////////////////////////////////////////////////////

#ifndef X3DGEOMETRICPROPNODE_H
#define X3DGEOMETRICPROPNODE_H

#include "X3DNode.h"

namespace X3DTK {
namespace X3D {

/// Base class of the <a href="../../doc/X3DSpecs/Part01/components/rendering.html">
/// Rendering component</a> defining an X3DGeometricPropertyNode
/// (<a href="../../doc/X3DSpecs/Part01/components/rendering.html#X3DGeometricPropertyNode">
/// documentation</a>).

class X3DGeometricPropertyNode : public X3DNode
{
public:  
  /// Constructor.
  X3DGeometricPropertyNode();
  /// Clones the node.
  virtual SFNode clone() const;
  /// Virtual destructor.
  virtual ~X3DGeometricPropertyNode();

protected:
  /// Constructs an X3DGeometricPropertyNode from its attributes.
  X3DGeometricPropertyNode(const X3DGeometricPropertyNode &N);
};

}
}

#endif
