////////////////////////////////////////////////////////////////////////////////
//                            X3DImageType.h                                  //
////////////////////////////////////////////////////////////////////////////////

#ifndef X3DIMAGETYPE_H
#define X3DIMAGETYPE_H

namespace X3DTK {

class X3DImageType
{
public:
  X3DImageType();
  virtual ~X3DImageType();
  virtual bool load(const char *fileName) = 0;  
//  void adaptToGLSize();
  
  inline unsigned short getWidth() const {return _width;};
  inline unsigned short getHeight() const {return _height;};
  inline int getPixelFormat() const {return _pixelFormat;};
  inline unsigned char* getData() const {return data;};
  void release();

protected:
  unsigned char *data;
  bool allocate(int pixelFormat, unsigned short width, unsigned short height);

private:
  int _pixelFormat;    
  unsigned short _width;
  unsigned short _height;
};

}

#endif
