////////////////////////////////////////////////////////////////////////////////
//                            X3DNode.h                                       //
////////////////////////////////////////////////////////////////////////////////

#ifndef X3DNODE_H
#define X3DNODE_H

#include "X3DAbstractNode.h"

namespace X3DTK {
namespace X3D {

/// Base class of the <a href="../../doc/X3DSpecs/Part01/components/core.html">
/// Core component</a> defining an X3DNode 
/// (<a href="../../doc/X3DSpecs/Part01/components/core.html#X3DNode">
/// documentation</a>) for all nodes in the X3D system.

class X3DNode : public X3DAbstractNode
{
public:
  /// Constructor.
  X3DNode();
  /// Clones the node.
  virtual SFNode clone() const;
  /// Virtual destructor.
  virtual ~X3DNode();

  /// Loads the attributes from a FileElement.
  virtual void load(const X3DFileElement *element);
  /// Writes the  of the node.
  virtual SFString write() const;

protected:
  /// Copy constructor.
  X3DNode(const X3DNode &N);
  
  /// Remove link between A and B.
  static void removeLink(SFNode father, SFNode child);
  /// Adds link between A and B.
  static void addLink(SFNode father, SFNode child);
};

}
}

#endif
