////////////////////////////////////////////////////////////////////////////////
//                            X3DNormalNode.h                                //
////////////////////////////////////////////////////////////////////////////////

#ifndef X3DNORMALNODE_H
#define X3DNORMALNODE_H

#include "X3DGeometricPropertyNode.h"

namespace X3DTK {
namespace X3D {
/// Base class of the <a href="../../doc/X3DSpecs/Part01/components/rendering.html">
/// Rendering component</a> defining an X3DNormalNode
/// (<a href="../../doc/X3DSpecs/Part01/components/rendering.html#X3DNormalNode">
/// documentation</a>).

class X3DNormalNode : public X3DGeometricPropertyNode
{
public:  
  /// Constructor.
  X3DNormalNode();
  /// Clones the node.
  virtual SFNode clone() const;
  /// Virtual destructor.
  virtual ~X3DNormalNode();
  
protected:
  /// Copy constructor.
  X3DNormalNode(const X3DNormalNode &N);
};

}
}

#endif
