////////////////////////////////////////////////////////////////////////////////
//                            X3DTextureNode.h                                //
////////////////////////////////////////////////////////////////////////////////

#ifndef X3DTEXTURENODE_H
#define X3DTEXTURENODE_H

#include "X3DAppearanceChildNode.h"

namespace X3DTK {
namespace X3D {

/// Base class of the <a href="../../doc/X3DSpecs/Part01/components/texturing.html">
/// Texturing component</a> defining an X3DTextureNode
/// (<a href="../../doc/X3DSpecs/Part01/components/texturing.html#X3DTextureNode">
/// documentation</a>).

class X3DTextureNode : public X3DAppearanceChildNode
{
public:  
  /// Constructor.
  X3DTextureNode();
  /// Clones the node.
  virtual SFNode clone() const;
  /// Virtual destructor.
  virtual ~X3DTextureNode();

protected:
  /// Copy constructor.	
  X3DTextureNode(const X3DTextureNode &N);
};

}
}

#endif
