////////////////////////////////////////////////////////////////////////////////
//                            X3DTextureTransformNode.h                       //
////////////////////////////////////////////////////////////////////////////////

#ifndef X3DTEXTURETRANSFORMNODE_H
#define X3DTEXTURETRANSFORMNODE_H

#include "X3DAppearanceChildNode.h"

namespace X3DTK {
namespace X3D {

/// Base class of the <a href="../../doc/X3DSpecs/Part01/components/texturing.html">
/// Texturing component</a> defining an X3DTextureTransformNode
/// (<a href="../../doc/X3DSpecs/Part01/components/texturing.html#X3DTextureTransformNode">
/// documentation</a>).

class X3DTextureTransformNode : public X3DAppearanceChildNode
{
public:  
  /// Constructor.
  X3DTextureTransformNode();
  /// Clones the node.
  virtual SFNode clone() const;
  /// Virtual destructor.
  virtual ~X3DTextureTransformNode();
  
protected:
  /// Copy constructor.
  X3DTextureTransformNode(const X3DTextureTransformNode &N);
};

}
}

#endif
