////////////////////////////////////////////////////////////////////////////////
//                            XercesFileElement.h                             //
////////////////////////////////////////////////////////////////////////////////

#ifndef XERCESFILEELEMENT_H
#define XERCESFILEELEMENT_H

#include "X3DFileElement.h"

namespace X3DTK {

class XercesFileElementImplementation;

/// Class providing an implementation of X3DFileElement based upon Xerces.

class XercesFileElement : public X3DFileElement
{
  friend class SAX2X3DHandler;
public:
  /// Gets the name.
  SFString getName() const;
  /// Gets the attribute at the index i.
  SFString getAttribute(int i) const;
  /// Gets the index of the attribute. Returns -1 if doesn't exist.
  int getIndexAttribute(const SFString &attribute) const;
  
private:
  XercesFileElementImplementation *impl;
  XercesFileElement(const SFString &name, const void *const attributes);
  ~XercesFileElement();  
};

}

#endif
