unix {
  contains(DEFINES, XERCES) {
    !isEmpty ( XERCES22_DIR ) {
      XERCES22_LIB_DIR=$$XERCES22_DIR/lib
      XERCES22_INCLUDE_DIR=$$XERCES22_DIR/include
    }
    else {
      isEmpty ( XERCES22_LIB_DIR ) {
        XERCES22_LIB_DIR=/usr/local/lib
      } 
      isEmpty ( XERCES22_INCLUDE_DIR ) {
        XERCES22_INCLUDE_DIR=/usr/local/include
      }
    }
    
    !exists ( $$XERCES22_LIB_DIR/libxerces-c.so.22 ) {
      error ( not found libxerces-c.so.22 in $$XERCES22_LIB_DIR ! specify XERCES22_DIR or XERCES22_LIB_DIR if installed elsewhere )
    }
  
    !exists ( $$XERCES22_INCLUDE_DIR/xercesc ) {
      error ( not found $$XERCES22_INCLUDE_DIR/xercesc ! specify XERCES22_DIR or XERCES22_INCLUDE_DIR if installed elsewhere )
    }
  }  
}

win32 {
  error ( windows not yet supported )
}

DESTDIR  = ../../../lib
OBJECTS_DIR = ../../../obj

INCLUDEPATH *= ../../../include/X3DTK \
               ../../../include/X3DTK/private \

contains(DEFINES, XERCES) {               
  INCLUDEPATH += $$XERCES22_INCLUDE_DIR/xercesc
  LIBS += -L$$XERCES22_LIB_DIR -lxerces-c
}  
