#include "DefaultGeometry3DCreator.h"
#include "Box.h"
#include "Cone.h"
#include "Cylinder.h"
#include "IndexedFaceSet.h"
#include "Sphere.h"

namespace X3DTK {
namespace X3D {

DefaultGeometry3DCreator::DefaultGeometry3DCreator()
{
  defineNewCreationFunction<DefaultGeometry3DCreator>("Box", &DefaultGeometry3DCreator::createBox);
  defineNewCreationFunction<DefaultGeometry3DCreator>("Cone", &DefaultGeometry3DCreator::createCone);
  defineNewCreationFunction<DefaultGeometry3DCreator>("Cylinder", &DefaultGeometry3DCreator::createCylinder);
  defineNewCreationFunction<DefaultGeometry3DCreator>("IndexedFaceSet", &DefaultGeometry3DCreator::createIndexedFaceSet);
  defineNewCreationFunction<DefaultGeometry3DCreator>("Sphere", &DefaultGeometry3DCreator::createSphere);
}

DefaultGeometry3DCreator::~DefaultGeometry3DCreator()
{
}

SFNode DefaultGeometry3DCreator::createBox() const
{
  return new Box();
}

SFNode DefaultGeometry3DCreator::createCone() const
{
  return new Cone();
}

SFNode DefaultGeometry3DCreator::createCylinder() const
{
  return new Cylinder();
}

SFNode DefaultGeometry3DCreator::createIndexedFaceSet() const
{
  return new IndexedFaceSet();
}

SFNode DefaultGeometry3DCreator::createSphere() const
{
  return new Sphere();
}

}
}
