/// This file is part of the X3DToolKit library
/// Copyright (C) 2002-2003  Yannick Le Goc (legoc@imag.fr)

/// http://www-imagis.imag.fr/Membres/Yannick.Legoc/X3D/


/// X3DToolKit is free software; you can redistribute it and/or modify
/// it under the terms of the GNU General Public License as published by
/// the Free Software Foundation; either version 2 of the License, or
/// (at your option) any later version.

/// X3DToolKit is distributed in the hope that it will be useful,
/// but WITHOUT ANY WARRANTY; without even the implied warranty of
/// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
/// GNU General Public License for more details.

/// You should have received a copy of the GNU General Public License
/// along with X3DToolKit; if not, write to the Free Software
/// Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
////////////////////////////////////////////////////////////////////////////////
//                            Image.h                                         //
////////////////////////////////////////////////////////////////////////////////

#ifndef IMAGE_H
#define IMAGE_H

#include "X3DImageType.h"

namespace X3DTK {

class Image
{
public:
  Image();
  Image(const char *fileName);
  ~Image();
  
  bool load(const char *fileName);  
  //void adaptToGLSize();
  
  inline unsigned short getWidth() const {return (_imageType != 0 ? _imageType->getWidth() : 0);};
  inline unsigned short getHeight() const {return (_imageType != 0 ? _imageType->getHeight() : 0);};
  inline int getPixelFormat() const {return (_imageType != 0 ? _imageType->getPixelFormat() : 0);};
  inline unsigned char* getData() const {return _imageType->getData();};
  
private:
  X3DImageType *_imageType;
};

}

#endif
