#include "MemReleaserAbstractVisitor.h"
#include "Scene.h"
#include "X3DAbstractNode.h"

#include <iostream>

using namespace std;

namespace X3DTK {

MemReleaserAbstractVisitor::MemReleaserAbstractVisitor()
: AbstractVisitor()
{
  // Enter functions.
  defineNewEnterFunction<MemReleaserAbstractVisitor, X3DAbstractNode>(&MemReleaserAbstractVisitor::enterX3DAbstractNode);
  
  // Walk on functions.
  defineNewWalkOnFunction<MemReleaserAbstractVisitor, X3DAbstractNode>(&MemReleaserAbstractVisitor::walkOnX3DAbstractNode);  
    
  // Leave functions.
  defineNewLeaveFunction<MemReleaserAbstractVisitor, X3DAbstractNode>(&MemReleaserAbstractVisitor::leaveX3DAbstractNode);

  // GlobalVariables assignation.
  globalVariables = GVManager::getInstanceOf<MemReleaserGlobalVariables>();
}

MemReleaserAbstractVisitor::~MemReleaserAbstractVisitor()
{
}

void MemReleaserAbstractVisitor::enterX3DAbstractNode(X3DAbstractNode *N) const
{
  // if here, then the parent has to be deleted.
  SFAbstractNode P = globalVariables->getParent();
  if (P != 0)
    P->removeChild(N);
    
  if (N->getParentList().size() == 0)
    globalVariables->setDelete(true);
  else
    globalVariables->setDelete(false);
      
  globalVariables->pushParent(N);
}

bool MemReleaserAbstractVisitor::walkOnX3DAbstractNode(X3DAbstractNode *N, SFAbstractNode child) const
{
  return globalVariables->getDelete();
}

void MemReleaserAbstractVisitor::leaveX3DAbstractNode(X3DAbstractNode *N) const
{
  globalVariables->popParent();
    
  if (globalVariables->getDelete())
    delete N;
  else
    globalVariables->setDelete(true);
}

}
