/// This file is part of the X3DToolKit library
/// Copyright (C) 2002-2003  Yannick Le Goc (legoc@imag.fr)

/// http://www-imagis.imag.fr/Membres/Yannick.Legoc/X3D/


/// X3DToolKit is free software; you can redistribute it and/or modify
/// it under the terms of the GNU General Public License as published by
/// the Free Software Foundation; either version 2 of the License, or
/// (at your option) any later version.

/// X3DToolKit is distributed in the hope that it will be useful,
/// but WITHOUT ANY WARRANTY; without even the implied warranty of
/// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
/// GNU General Public License for more details.

/// You should have received a copy of the GNU General Public License
/// along with X3DToolKit; if not, write to the Free Software
/// Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
////////////////////////////////////////////////////////////////////////////////
//                            MemReleaserGlobalVariables.h                    //
////////////////////////////////////////////////////////////////////////////////

#ifndef MEMRELEASERGLOBALVARIABLES_H
#define MEMRELEASERGLOBALVARIABLES_H

#include "GlobalVariables.h"

namespace X3DTK {

/// GlobalVariables for the MemReleaser module.

class MemReleaserGlobalVariables : public GlobalVariables
{
public:
  /// Constructor.
  MemReleaserGlobalVariables();
  /// Destructor.
  virtual ~MemReleaserGlobalVariables();

  /// Initializes the traversal.
  void init();
  /// Finishes the traversal.
  void finish();
  
  /// Pushes the parent.
  void pushParent(SFAbstractNode P);
  /// Pops the parent.
  void popParent();
  /// Sets the current node to be deleted.
  void setDelete(bool value);
  
  /// Gets the parent.
  SFAbstractNode getParent() const {return _nodeStack.front();};
  /// Gets the current node to be deleted or not.
  bool getDelete() const {return _toDelete;};

private: 
  MFAbstractNode _nodeStack;
  bool _toDelete;  
};

}

#endif
