#include "XercesFileElement.h"

#include <xercesc/util/XMLString.hpp>
#include <xercesc/sax2/Attributes.hpp>

#include <iostream>

using namespace std;
XERCES_CPP_NAMESPACE_USE

namespace X3DTK {

class X3DTK::XercesFileElementImplementation
{
public:
  XercesFileElementImplementation(){};
  
  SFString name;
  XERCES_CPP_NAMESPACE_QUALIFIER Attributes *attributes;
};

XercesFileElement::XercesFileElement(const SFString &name, const void *const attributes)
: impl(new XercesFileElementImplementation())
{
  impl->name = name;
  impl->attributes = (Attributes *)attributes;
}

XercesFileElement::~XercesFileElement()
{
}

SFString XercesFileElement::getName() const
{
  return impl->name;
}

SFString XercesFileElement::getAttribute(int i) const
{
  return XMLString::transcode(impl->attributes->getValue(i));
}

int XercesFileElement::getIndexAttribute(const SFString &attribute) const
{
  return impl->attributes->getIndex(XMLString::transcode((const char *)attribute));
}

}
