#include "ColorRGBA.h"

#include <iostream>

using namespace std;

namespace X3DTK {
namespace X3D {

ColorRGBA::ColorRGBA()
: X3DColorNode()
{
  defineTypeName("ColorRGBA", "Rendering");
}

ColorRGBA::ColorRGBA(const MFColorRGBA &color)
: X3DColorNode(), _color(color)
{
  defineTypeName("ColorRGBA", "Rendering");
}

ColorRGBA::ColorRGBA(const ColorRGBA &C)
: X3DColorNode(C), _color(C._color)
{
}

SFNode ColorRGBA::clone() const
{
  return new ColorRGBA(*this);
}

ColorRGBA::~ColorRGBA()
{
}

void ColorRGBA::setColor(const MFColorRGBA &color)
{
  _color = color;
}

void ColorRGBA::load(const X3DFileElement *element)
{
  int index;
  index = element->getIndexAttribute("color");
  if (index != -1)
    _color = MFColorRGBA(element->getAttribute(index));
}

SFString ColorRGBA::write() const
{
  SFString attr;
  if (!_color.empty())
    attr += " color=\"" + toSFString(_color) + "\"";
    
  return attr;
}

}
}
