TEMPLATE = lib 
CONFIG *= staticlib
TARGET = x3dnodes

VPATH = Type \
        FileElement \
        Core \
        Geometry3D \
        Grouping \
        Rendering \
        Shape \
        Texturing \

TARGETDEPS = ../../../lib/libx3dtypes.a \

HEADERS = X3DFileElement.h \
          Scene.h \
          X3DNode.h \
	  X3DObject.h \
	  Cylinder.h \
          Cone.h \
	  Sphere.h \
          Box.h \
          IndexedFaceSet.h \
	  X3DBoundedObject.h \
	  X3DChildNode.h \
	  X3DGroupingNode.h \
	  Group.h \
          StaticGroup.h \
	  Transform.h \
          Color.h \
          ColorRGBA.h \
          Coordinate.h \
          IndexedLineSet.h \
          Normal.h \
          PointSet.h \
          TriangleFanSet.h \
          TriangleSet.h \
          TriangleStripSet.h \
          X3DColorNode.h \
  	  X3DComposedGeometryNode.h \
          X3DCoordinateNode.h \
          X3DGeometricPropertyNode.h \
          X3DGeometry3DNode.h \
	  X3DGeometryNode.h \
          X3DNormalNode.h \
	  Appearance.h \
	  FillProperties.h \
	  LineProperties.h \
	  Material.h \
	  Shape.h \
	  X3DAppearanceChildNode.h \
	  X3DAppearanceNode.h \
	  X3DMaterialNode.h \
	  X3DShapeNode.h \
	  X3DTextureNode.h \
          X3DTextureCoordinateNode.h \	
	  X3DTextureTransformNode.h \
          X3DTexture2DNode.h \	
          ImageTexture.h \
          TextureCoordinate.h \
          
SOURCES = X3DFileElement.cpp \
          Scene.cpp \
          X3DNode.cpp \
	  X3DObject.cpp \
	  Cylinder.cpp \
          Cone.cpp \
	  Sphere.cpp \
          Box.cpp \
          IndexedFaceSet.cpp \
	  X3DBoundedObject.cpp \
	  X3DChildNode.cpp \
	  X3DGroupingNode.cpp \
	  Group.cpp \
          StaticGroup.cpp \
	  Transform.cpp \
          Color.cpp \
          ColorRGBA.cpp \
          Coordinate.cpp \
          IndexedLineSet.cpp \
          Normal.cpp \
          PointSet.cpp \
          TriangleFanSet.cpp \
          TriangleSet.cpp \          
          TriangleStripSet.cpp \
          X3DColorNode.cpp \
  	  X3DComposedGeometryNode.cpp \
          X3DCoordinateNode.cpp \
          X3DGeometricPropertyNode.cpp \
          X3DGeometry3DNode.cpp \
	  X3DGeometryNode.cpp \
          X3DNormalNode.cpp \
          Appearance.cpp \
	  FillProperties.cpp \
	  LineProperties.cpp \
	  Material.cpp \
	  Shape.cpp \
	  X3DAppearanceChildNode.cpp \
	  X3DAppearanceNode.cpp \
	  X3DMaterialNode.cpp \
	  X3DShapeNode.cpp \
	  X3DTextureNode.cpp \
          X3DTextureCoordinateNode.cpp \
	  X3DTextureTransformNode.cpp \
          X3DTexture2DNode.cpp \	
          ImageTexture.cpp \
          TextureCoordinate.cpp \ 	

contains(DEFINES, XERCES) {           
  HEADERS += XercesFileElement.h 
  SOURCES += XercesFileElement.cpp 
}
else {
  HEADERS += QFileElement.h
  SOURCES += QFileElement.cpp 
} 

include(../../X3DToolKit.pri)
