#include "GLBuilderGroupingVisitor.h"
#include "Group.h"
#include "StaticGroup.h"
#include "Transform.h"
#include "GLGroup.h"
#include "GLStaticGroup.h"
#include "GLTransform.h"

#include <iostream>

using namespace std;

namespace X3DTK {
namespace X3D {

GLBuilderGroupingVisitor::GLBuilderGroupingVisitor()
: GroupingVisitor()
{
  // Enter functions.
  defineNewEnterFunction<GLBuilderGroupingVisitor, Group>(&GLBuilderGroupingVisitor::enterGroup);
  defineNewEnterFunction<GLBuilderGroupingVisitor, StaticGroup>(&GLBuilderGroupingVisitor::enterStaticGroup);
  defineNewEnterFunction<GLBuilderGroupingVisitor, Transform>(&GLBuilderGroupingVisitor::enterTransform);

  // GlobalVariables assignation.
  globalVariables = GVManager::getInstanceOf<GLBuilderGlobalVariables>();
}

GLBuilderGroupingVisitor::~GLBuilderGroupingVisitor()
{
}

void GLBuilderGroupingVisitor::enterGroup(Group *G) const
{
  GL::Group *GG = new GL::Group();
  GG->setX3DReference(G);
  globalVariables->getTop()->addChild(GG);
  globalVariables->pushNode(GG);
}

void GLBuilderGroupingVisitor::enterStaticGroup(StaticGroup *S) const
{
  GL::StaticGroup *GS = new GL::StaticGroup();
  GS->setX3DReference(S);
  globalVariables->getTop()->addChild(GS);
  globalVariables->pushNode(GS); 
}

void GLBuilderGroupingVisitor::enterTransform(Transform *T) const
{
  GL::Transform *GT = new GL::Transform();
  GT->setX3DReference(T);
  globalVariables->getTop()->addChild(GT);
  globalVariables->pushNode(GT);
}

}
}
