#include "GLRendererGroupingVisitor.h"
#include "GLGroup.h"
#include "GLStaticGroup.h"
#include "GLTransform.h"

namespace X3DTK {
namespace GL {

RendererGroupingVisitor::RendererGroupingVisitor()
: GroupingVisitor()
{
  // Leave functions
  defineNewLeaveFunction<RendererGroupingVisitor, Transform>(&RendererGroupingVisitor::leaveTransform);

  // GlobalVariables assignation.
  globalVariables = GVManager::getInstanceOf<RendererGlobalVariables>();
}

RendererGroupingVisitor::~RendererGroupingVisitor()
{
}

void RendererGroupingVisitor::leaveTransform(Transform *G) const
{
  glMatrixMode(GL_MODELVIEW);
  glPopMatrix();  
}

}
}
