#include "GLUpdater.h"
#include "GLDefaultDFS.h"
#include "GLUpdaterCoreVisitor.h"

#include <iostream>

using namespace std;

namespace X3DTK {
namespace GL {

Updater::Updater()
: X3DUpdater()
{
  globalVariables = GVManager::getInstanceOf<UpdaterGlobalVariables>();
  dfs = new DefaultDFS();
  
  dfs->setComponentVisitor(new UpdaterCoreVisitor());
}

Updater::~Updater()
{
  delete dfs;
}

void Updater::setComponentVisitor(X3DComponentVisitor *component)
{
  dfs->setComponentVisitor(component);
}

void Updater::update(X3DNode *N)
{
  dfs->traverse(N);
}

}
}
