#include "TemplateMeshBuilderCoreVisitor.h"
#include "Scene.h"
#include "MeshScene.h"
#include <iostream>

using namespace std;

namespace X3DTK {
namespace X3D {

TemplateMeshBuilderCoreVisitor::TemplateMeshBuilderCoreVisitor()
: CoreVisitor()
{
  // Enter functions.
  defineNewEnterFunction<TemplateMeshBuilderCoreVisitor, Scene>(&TemplateMeshBuilderCoreVisitor::enterScene);
  // Leave functions.
  defineNewLeaveFunction<TemplateMeshBuilderCoreVisitor, X3DNode>(&TemplateMeshBuilderCoreVisitor::leaveX3DNode);

  // GlobalVariables assignation.
  globalVariables = GVManager::getInstanceOf<TemplateMeshBuilderGlobalVariables>();
};

TemplateMeshBuilderCoreVisitor::~TemplateMeshBuilderCoreVisitor() 
{
};

void TemplateMeshBuilderCoreVisitor::enterScene(Scene *S) const
{
  Mesh::Scene *MS = new Mesh::Scene();
  globalVariables->pushNode(MS);
};

void TemplateMeshBuilderCoreVisitor::leaveX3DNode(X3DNode *N) const
{
  globalVariables->popNode();
};

}
}
