#include "TemplateMeshBuilderShapeVisitor.h"
#include "Appearance.h"
#include "FillProperties.h"
#include "LineProperties.h"
#include "Material.h"
#include "Shape.h"
#include "X3DGeometryNode.h"

namespace X3DTK {
namespace X3D {

TemplateMeshBuilderShapeVisitor::TemplateMeshBuilderShapeVisitor()
: ShapeVisitor()
{
  // Enter functions.
  defineNewEnterFunction<TemplateMeshBuilderShapeVisitor, Shape>(&TemplateMeshBuilderShapeVisitor::enterShape);
  // WalkOn functions.
  defineNewWalkOnFunction<TemplateMeshBuilderShapeVisitor, Shape>(&TemplateMeshBuilderShapeVisitor::walkOnShape);
  // Leave functions.
  defineNewLeaveFunction<TemplateMeshBuilderShapeVisitor, Shape>(&TemplateMeshBuilderShapeVisitor::leaveShape);

  // GlobalVariables assignation.
  globalVariables = GVManager::getInstanceOf<TemplateMeshBuilderGlobalVariables>();
}

TemplateMeshBuilderShapeVisitor::~TemplateMeshBuilderShapeVisitor()
{
}

void TemplateMeshBuilderShapeVisitor::enterShape(Shape *S) const
{
}

bool TemplateMeshBuilderShapeVisitor::walkOnShape(Shape *S, SFAbstractNode child) const
{
  return (dynamic_cast<X3DGeometryNode *>(child) != 0);
}

void TemplateMeshBuilderShapeVisitor::leaveShape(Shape *S) const
{
}

}
}
